/* CVS Repository *
 * $Id: su-run.c,v 1.2 2001/02/06 05:09:16 cireland Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <shadow.h>
#include <pwd.h>
#include <syslog.h>

int chk_auth(char user[], char passwd[]);
int main(int argc, char *argv[]) {
  char user[10], command[512], auth_code[255];
  char su_user[10], su_extra[16];
  unsigned int e_uid, p_ret;
  
  if(geteuid() != 0){
    exit(-1);
  }

  openlog("su-run", 0, LOG_USER);
  if(argc < 4) {
    exit(-1);
  } else if(argc == 4) {
    strncpy(user, argv[1],sizeof(user));
    strncpy(auth_code, argv[2],sizeof(auth_code));
    if(chk_auth(user, auth_code) != 0) {
      exit(1);
    }
    strncpy(command, argv[3],sizeof(command));
    syslog(LOG_INFO, "USER=%s CMD=%s", user, command);
    execl("/bin/sh", "sh", "-c", command, 0);
  } else if(argc == 6) {
    strncpy(user, argv[1],sizeof(user));
    strncpy(auth_code, argv[2],sizeof(user));
    if(chk_auth(user, auth_code) != 0) {
      exit(1);
    }
    if(strcmp(argv[3], "-u") != 0) {
      exit(-1);
    }
    strncpy(su_user, argv[4],sizeof(su_user));
    strncpy(su_extra, argv[5],sizeof(su_extra));
    e_uid = get_uid(su_user);

    syslog(LOG_INFO, "USER=%s AS= %s CMD=%s", user, su_user , su_extra);

    setuid(e_uid);
    p_ret = execl("/bin/sh", "sh", "-c", su_extra, 0);
  } else {
    exit(-1);
  }
  closelog();
  exit(p_ret);
}

int chk_auth(char user[], char passwd[]) {
  char r_passwd[255], u_passwd[255];
  struct passwd pswd_entry;
  struct spwd shdw_entry;

  if(getpwnam(user) == NULL) {
    return(-1);
  }
  
  pswd_entry = *getpwnam(user);
  strncpy(u_passwd, pswd_entry.pw_passwd,sizeof(u_passwd));

  if(! strcmp("x", u_passwd)) {
    shdw_entry = *getspnam(user);
    strncpy(u_passwd, shdw_entry.sp_pwdp,sizeof(u_passwd));
  }

  sprintf(r_passwd, "%s", crypt(passwd, u_passwd));
  if(strcmp(r_passwd, u_passwd)) {
    return(-1);
  } else {
    return(0);
  }
}

int get_uid(char user[]) {
  struct passwd pswd_entry;
  unsigned int u_num;

  if(getpwnam(user) == NULL) {
    return(-1);
  }
  
  pswd_entry = *getpwnam(user);
  u_num = pswd_entry.pw_uid;

  return(u_num);
}
